function []=Untitled

fid = fopen('ScatterInput.txt');
Input = fscanf(fid, '%g %g', [9 inf]);
fclose(fid);

imageX=Input(1,1); imageY=Input(2,1);
stepwidth=Input(3,1);
jitterfactor=Input(4,1);
numberofinstances=0;
scalingcenter=Input(5,1);
scalingdev=Input(6,1);
rotationXZ=Input(7,1);
rotationY=Input(8,1);
halfwidth=Input(9,1); %shearing


TerrainandScatter=zeros(512,512);
%Scatter=ones(512,512);
Terrain=zeros(512,512);
Scatter=TerrainandScatter(:,:,1)-Terrain;

% InstanceTshearall=zeros(2,2);
%          InstanceTRshearall=zeros(2,2);
          InstanceTSRshearall=zeros(2,2);
%           InstanceTrans=zeros(4,4);
%           InstanceTall=zeros(2,2);
%           Instanceshear=zeros(4,4);
%          InstanceSRall=zeros(2,2);
%          InstanceTRall=zeros(2,2);
%          InstanceTSRall=zeros(2,2);
%  InstanceTSall=zeros(2,2);


yAll=1;
p=1;  %counter for terrain scatter plot

for y=2*stepwidth:stepwidth:imageY-2*stepwidth  %from 4 to ...-4 because jitter might otherwise exceed matrix dimensions
 
for x= 2*stepwidth:stepwidth:imageX-2*stepwidth
     
      % jitter
      xj=x+jitterfactor*stepwidth/4.*randn(1,1);
      yj=y+jitterfactor*stepwidth/4.*randn(1,1);
          
%       xTerrainVis(1,p)=xj;  %create xyz for scatterplot
%       yTerrainVis(1,p)=yj;  %create xyz for scatterplot
%       zTerrainVis(1,p)=round(Terrain(round(yj),round(xj)));
%       p=p+1;
      
      
      % start for instancing
 InstanceTrans=zeros(4,4);
      InstanceTrans(1,1)=1; InstanceTrans(2,2)=1; InstanceTrans(3,3)=1; InstanceTrans(4,4)=1; 
      
      %Translation
if Scatter(round(yj),round(xj))> 0
         InstanceTrans(1,4)=xj;
         InstanceTrans(2,4)=round(Terrain(round(yj),round(xj)))/(256/64);  %y is up in Octane
         %InstanceTrans(2,4)=0;  %y is up in Octane
         InstanceTrans(3,4)=yj;
         
         InstanceTall=zeros(2,2);
         InstanceTall(yAll:yAll+2,1:4)=InstanceTrans(1:3,1:4);
         
         %Scaling
         
         xs = scalingcenter + scalingdev.*randn(1,1);
         ys = scalingcenter + scalingdev.*randn(1,1);  %up in Octane
         zs = scalingcenter + scalingdev.*randn(1,1);
         
         %InstanceScale = makehgtform('scale',[xs,ys,zs]);
         InstanceScale=[xs,0,0,0; 0,ys,0,0; 0,0,zs,0; 0,0,0,1];
         
         InstanceTS=InstanceTrans*InstanceScale;
         InstanceTSall=zeros(2,2);
         InstanceTSall(yAll:yAll+2,1:4)=InstanceTS(1:3,1:4);
         
         
         %Rotation
         
         
         xr = 0 + rotationXZ.*randn(1,1);
         yr = 0 + rotationY.*randn(1,1);
         zr = 0 + rotationXZ.*randn(1,1);
         
         %Rx = makehgtform('xrotate',xr*6.28/360);
         Rx=[1,0,0,0;0,cos(xr*6.28/360),-sin(xr*6.28/360),0;0,sin(xr*6.28/360),cos(xr*6.28/360),0;0,0,0,1];
         %Ry = makehgtform('yrotate',yr*6.28/360);  %%%%%% up direction Octane
         Ry=[cos(yr*6.28/360),0,sin(yr*6.28/360),0; 0,1,0,0; -sin(yr*6.28/360),0,cos(yr*6.28/360),0; 0,0,0,1];
         %Rz = makehgtform('zrotate',zr*6.28/360);
         Rz=[cos(zr*6.28/360),-sin(zr*6.28/360),0,0; sin(zr*6.28/360),cos(zr*6.28/360),0,0; 0,0,1,0; 0,0,0,1];
    
        
         InstanceRot=Rx*Ry*Rz;
         
         InstanceSR=InstanceScale*InstanceRot;
         InstanceTR=InstanceTrans*InstanceRot;
         InstanceTSR=InstanceTrans*InstanceScale*InstanceRot;
         
         InstanceSRall=zeros(2,2);
         InstanceTRall=zeros(2,2);
         InstanceTSRall=zeros(2,2);
         InstanceSRall(yAll:yAll+2,1:4)=InstanceSR(1:3,1:4);
         InstanceTRall(yAll:yAll+2,1:4)=InstanceTR(1:3,1:4);
         InstanceTSRall(yAll:yAll+2,1:4)=InstanceTSR(1:3,1:4);
        
         %Shearing
         Instanceshear=zeros(4,4);
         
         ash = 0 + halfwidth.*randn(1,1);
         bsh = 0 + halfwidth.*randn(1,1);
         csh = 0 + halfwidth.*randn(1,1);
         dsh = 0 + halfwidth.*randn(1,1);
         esh = 0 + halfwidth.*randn(1,1);
         fsh = 0 + halfwidth.*randn(1,1);
         Instanceshear(1,1)=1;Instanceshear(1,2)=ash;Instanceshear(1,3)=bsh;Instanceshear(1,4)=0;
         Instanceshear(2,1)=csh;Instanceshear(2,2)=1;Instanceshear(2,3)=dsh;Instanceshear(2,4)=0;
         Instanceshear(3,1)=esh;Instanceshear(3,2)=fsh;Instanceshear(3,3)=1;Instanceshear(3,4)=0;
         Instanceshear(4,1)=0;Instanceshear(4,2)=0;Instanceshear(4,3)=0;Instanceshear(4,4)=1;
         
         InstanceTshear=InstanceTrans*Instanceshear;
         InstanceTRshear=InstanceTrans*InstanceRot*Instanceshear;
         InstanceTSRshear=InstanceTrans*InstanceScale*InstanceRot*Instanceshear;
         
         InstanceTshearall=zeros(2,2);
         InstanceTRshearall=zeros(2,2);
         InstanceTSRshearall=zeros(2,2);
         
         InstanceTshearall(yAll:yAll+2,1:4)=InstanceTshear(1:3,1:4);
         InstanceTRshearall(yAll:yAll+2,1:4)=InstanceTRshear(1:3,1:4);
         InstanceTSRshearall(yAll:yAll+2,1:4)=InstanceTSRshear(1:3,1:4);
         
         yAll=yAll+3;
         
         numberofinstances=numberofinstances+1;
         
%         ScatterVisX(1, numberofinstances)=InstanceTrans(1,4);
%         ScatterVisY(1, numberofinstances)=InstanceTrans(3,4);
%         ScatterVisZ(1, numberofinstances)=InstanceTrans(2,4);  %is Y here, accounting for xyz in Matlab
%         
        
        
end  
        
end
end
 



%%%%%%%%%%%%%%%%%%%%%%%%Randomizing

InstanceTSRshearallrearrange=zeros(2,2);   % rearrange to line format like in Octane
for x=1:1:numberofinstances
    
    substart=x*3-2;
    submid=x*3-1;
    subend=x*3;

InstanceTSRshearallrearrange(subend/3,1:4)=InstanceTSRshearall(substart,1:4);

InstanceTSRshearallrearrange(subend/3,5:8)=InstanceTSRshearall(submid,1:4);

InstanceTSRshearallrearrange(subend/3,9:12)=InstanceTSRshearall(subend,1:4);
   
end

InstanceTSRshearallrandom=InstanceTSRshearallrearrange(randperm(size(InstanceTSRshearallrearrange,1)),:);

end