
Input=importdata('ScatterInputrandom.txt');  %in current folder, written in one column
imageX=Input(1,1); imageY=Input(2,1);
Quantity=Input(3,1);
TransCenter=Input(4,1);  %128
TransWidth=Input(5,1);   %100
TransCenterY=Input(6,1);  %128
TransWidthY=Input(7,1);  %128
Distribution=Input(8,1); % 0 or 1

scalingcenter=Input(9,1);
scalingdev=Input(10,1);
rotationXZ=Input(11,1);
rotationY=Input(12,1);
halfwidth=Input(13,1); %shearing

%%DISABLE non overlappting at line 74

imageX=Input(1,1); imageY=Input(2,1);
numberofinstances=1; occurence = 0;
InstanceTall=zeros(3,4);

ScatterVisX=zeros(1,1);
ScatterVisY=zeros(1,1);
ScatterVisZ=zeros(1,1);

%Translation and Terrain, Then Scaling, Then Rotation
yAll=1;

for n=1:1:Quantity
       
      InstanceTrans=zeros(4,4);
      InstanceTrans(1,1)=1; InstanceTrans(2,2)=1; InstanceTrans(3,3)=1; InstanceTrans(4,4)=1; 
      
      %Translation /put coordinates for random distribution here.
  
         if Distribution == 0
         %normal distribution peak 128 standdev 50
         InstanceTrans(1,4)=TransCenter + TransWidth.*randn(1,1);
         InstanceTrans(2,4)=TransCenterY + TransWidthY.*randn(1,1);  %y is up in Octane
         InstanceTrans(3,4)=TransCenter + TransWidth.*randn(1,1);
         end
         
         if Distribution == 1
         %even distribution von 1 bis 128
         InstanceTrans(1,4)=randi(TransCenter);
         InstanceTrans(2,4)=randi(TransCenterY);  %y is up in Octane
         InstanceTrans(3,4)=randi(TransCenter);
         end
         
         InstanceTrans=round(InstanceTrans);
         
   
         %start occurence check
         negoccurencecounter=1;
for Tallsub=1:1:numberofinstances
         
         if Tallsub>1   % all but first instance  
         occurence = isequal(InstanceTrans(1:3,1:4),InstanceTall((Tallsub-1)*3-2:(Tallsub-1)*3,1:4));
      
         %occurence = isequal(InstanceTrans(1:3,1:4),InstanceTrans(1:3,1:4));
         
         if occurence == 0
             negoccurencecounter=negoccurencecounter+1;
         end
         end
end

          % go on as standard random if occurrence check was negative (no
          % occurences)
          
           if numberofinstances==negoccurencecounter 
           
         % if numberofinstances==numberofinstances   % for disabling
         % occurence check
         
         InstanceTall(yAll:yAll+2,1:4)=InstanceTrans(1:3,1:4); 
         
        ScatterVisX(1,numberofinstances)=InstanceTrans(1,4);
        ScatterVisY(1,numberofinstances)=InstanceTrans(3,4);
        ScatterVisZ(1,numberofinstances)=InstanceTrans(2,4);  %is Y here, accounting for xyz in Matlab
      
          
         
               
         %Scaling
         
         xs = Input(9,1) + Input(10,1).*randn(1,1);
         ys = Input(9,1) + Input(10,1).*randn(1,1);  %up in Octane
         zs = Input(9,1)+ Input(10,1).*randn(1,1);
         
         InstanceScale = makehgtform('scale',[xs,ys,zs]);
         
         InstanceTS=InstanceTrans*InstanceScale;
         InstanceTSall(yAll:yAll+2,1:4)=InstanceTS(1:3,1:4);
        
         
         %Rotation  
         
         
         xr = 0 + rotationXZ.*randn(1,1);
         yr = 0 + rotationY.*randn(1,1);
         zr = 0 + rotationXZ.*randn(1,1);
         Rx = makehgtform('xrotate',xr*6.28/360);
         Ry = makehgtform('yrotate',yr*6.28/360);  %%%%%% up direction Octane
         Rz = makehgtform('zrotate',zr*6.28/360);
         InstanceRot=Rx*Ry*Rz;
         
         InstanceSR=InstanceScale*InstanceRot;
         InstanceTR=InstanceTrans*InstanceRot;
         InstanceTSR=InstanceTrans*InstanceScale*InstanceRot;
         
         InstanceSRall(yAll:yAll+2,1:4)=InstanceSR(1:3,1:4);
         InstanceTRall(yAll:yAll+2,1:4)=InstanceTR(1:3,1:4);
         InstanceTSRall(yAll:yAll+2,1:4)=InstanceTSR(1:3,1:4);
        
         %Shearing
         Instanceshear=zeros(4,4);
         %halfwidth=0.0;  %amount of shearing here
         ash = 0 + halfwidth.*randn(1,1);
         bsh = 0 + halfwidth.*randn(1,1);
         csh = 0 + halfwidth.*randn(1,1);
         dsh = 0 + halfwidth.*randn(1,1);
         esh = 0 + halfwidth.*randn(1,1);
         fsh = 0 + halfwidth.*randn(1,1);
         Instanceshear(1,1)=1;Instanceshear(1,2)=ash;Instanceshear(1,3)=bsh;Instanceshear(1,4)=0;
         Instanceshear(2,1)=csh;Instanceshear(2,2)=1;Instanceshear(2,3)=dsh;Instanceshear(2,4)=0;
         Instanceshear(3,1)=esh;Instanceshear(3,2)=fsh;Instanceshear(3,3)=1;Instanceshear(3,4)=0;
         Instanceshear(4,1)=0;Instanceshear(4,2)=0;Instanceshear(4,3)=0;Instanceshear(4,4)=1;
         
         InstanceTshear=InstanceTrans*Instanceshear;
         InstanceTRshear=InstanceTrans*InstanceRot*Instanceshear;
         InstanceTSRshear=InstanceTrans*InstanceScale*InstanceRot*Instanceshear;
         
         InstanceTshearall(yAll:yAll+2,1:4)=InstanceTshear(1:3,1:4);
         InstanceTRshearall(yAll:yAll+2,1:4)=InstanceTRshear(1:3,1:4);
         InstanceTSRshearall(yAll:yAll+2,1:4)=InstanceTSRshear(1:3,1:4);
%        
         yAll=yAll+3;
         
         numberofinstances=numberofinstances+1;
         
         end
end
                

scatter3(ScatterVisX,ScatterVisY,ScatterVisZ,5,'filled');
             

 
 dlmwrite('InstanceTall.txt', InstanceTall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')
 dlmwrite('InstanceTSall.txt', InstanceTSall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')
 dlmwrite('InstanceSRall.txt', InstanceSRall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')
 dlmwrite('InstanceTRall.txt', InstanceTRall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')
 dlmwrite('InstanceTSRall.txt', InstanceTSRall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')
 
 dlmwrite('InstanceTshearall.txt', InstanceTshearall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')
 dlmwrite('InstanceTRshearall.txt', InstanceTRshearall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')
 dlmwrite('InstanceTSRshearall.txt', InstanceTSRshearall, 'delimiter', ' ', 'precision', '%.2f','newline', 'pc')




